// ************************************************************************
// ***************************** CEF4Delphi *******************************
// ************************************************************************
//
// CEF4Delphi is based on DCEF3 which uses CEF to embed a chromium-based
// browser in Delphi applications.
//
// The original license of DCEF3 still applies to CEF4Delphi.
//
// For more information about CEF4Delphi visit :
//         https://www.briskbard.com/index.php?lang=en&pageid=cef
//
//        Copyright © 2021 Salvador Diaz Fau. All rights reserved.
//
// ************************************************************************
// ************ vvvv Original license and comments below vvvv *************
// ************************************************************************
(*
 *                       Delphi Chromium Embedded 3
 *
 * Usage allowed under the restrictions of the Lesser GNU General Public License
 * or alternatively the restrictions of the Mozilla Public License 1.1
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Unit owner : Henri Gourvest <hgourvest@gmail.com>
 * Web site   : http://www.progdigy.com
 * Repository : http://code.google.com/p/delphichromiumembedded/
 * Group      : http://groups.google.com/group/delphichromiumembedded
 *
 * Embarcadero Technologies, Inc is not permitted to use or redistribute
 * this source code without explicit permission.
 *
 *)

unit InitSubProcess;

{$mode ObjFPC}{$H+}
{ $I cef.inc}

interface

uses
  GlobalCefApplication, uCEFApplication, uCEFWorkScheduler;

implementation

initialization
  CreateGlobalCEFApp;
  GlobalCEFApp.FrameworkDirPath:='/opt/CEF/current/dist';
  GlobalCEFApp.ResourcesDirPath:='/opt/CEF/current/dist';
  GlobalCEFApp.LocalesDirPath:='/opt/CEF/current/dist/locales';
  if not GlobalCEFApp.StartMainProcess then begin
    if GlobalCEFWorkScheduler <> nil then
      GlobalCEFWorkScheduler.StopScheduler;
    DestroyGlobalCEFApp;
    DestroyGlobalCEFWorkScheduler;
    halt(0); // exit the subprocess
  end;

end.

